(defun crear-ventana()
  (setf mi-ventana
       (COMMON-GRAPHICS:open-stream
        COMMON-GRAPHICS:'bitmap-window
        ACLWIN:*lisp-main-window*
        :io
        :title "Mundo de bloques")))

(defun crear-bloque()
  (setf my-box (COMMON-GRAPHICS:make-box 20 20 100 80)))


(defun pintar-bloque()
  (COMMON-GRAPHICS:draw-box mi-ventana my-box))

(setf *inicio-ventana-horizontal* 20)
(setf *inicio-ventana-vertical* 230)
(setf *pixel-por-unidad* 30)


(defun crear-mesa()
  (setf mi-mesa (COMMON-GRAPHICS:make-box 
                 *inicio-ventana-horizontal* *inicio-ventana-vertical* 
                 (+ *inicio-ventana-horizontal* (* 10 *pixel-por-unidad*)) 
                 (+ *inicio-ventana-vertical* 10)))
  (COMMON-GRAPHICS:draw-box mi-ventana mi-mesa))

;;(defun draw-triangulo(posx posy dimx dimy)
;;)

;;sirve para cuadrados y rectangulos

(defun borrar-elemento(obj)
  (COMMON-GRAPHICS:erase-box mi-ventana (get-value obj 'dibujo))
  )

(defun borrar-circulo(obj)
   (setf x (+ *inicio-ventana-horizontal* 
             (* *pixel-por-unidad* (first (get-value obj 'posicion)))))
  (setf y (- *inicio-ventana-vertical* 
             (* *pixel-por-unidad* (second (get-value obj 'posicion)))))
  (set-value obj 'dibujo (COMMON-GRAPHICS:erase-circle mi-ventana (COMMON-GRAPHICS:make-position 
             (+ x (/ (* *pixel-por-unidad* (first (get-value obj 'dimension))) 2))
             (- y (/ (* *pixel-por-unidad* (second (get-value obj 'dimension))) 2))) 
             (/ (* *pixel-por-unidad* (first (get-value obj 'dimension))) 2)))

  )


(defun borrar-triangulo(obj)
  ;; obj es el nombre del bloque a pintar con propiedades
  ;; posicion, (posx posy)  y dimension, un entero
  (setf x (+ *inicio-ventana-horizontal* 
             (* *pixel-por-unidad* (first (get-value obj 'posicion)))))
  (setf y (- *inicio-ventana-vertical* 
             (* *pixel-por-unidad* (second (get-value obj 'posicion)))))
  (setf base (* *pixel-por-unidad* (first (get-value obj 'dimension))))
  (COMMON-GRAPHICS:erase-line mi-ventana (COMMON-GRAPHICS:make-position x y) 
                             (COMMON-GRAPHICS:make-position (+ x base) y))
  (COMMON-GRAPHICS:erase-line mi-ventana (COMMON-GRAPHICS:make-position x y) 
                             (COMMON-GRAPHICS:make-position (+ x (/ base 2)) (- y base)))
  (COMMON-GRAPHICS:erase-line mi-ventana (COMMON-GRAPHICS:make-position (+ x (/ base 2)) (- y base)) 
                             (COMMON-GRAPHICS:make-position (+ x base) y)))

                         
(defun pintar-elemento(obj)
  ;; obj es el nombre del bloque a pintar con propiedades
  ;; posicion, (posx posy)  y dimension, un entero
  (setf x (+ *inicio-ventana-horizontal* 
             (* *pixel-por-unidad* (first (get-value obj 'posicion)))))
  (setf y (- *inicio-ventana-vertical* 
             (* *pixel-por-unidad* (second (get-value obj 'posicion)))))
  (set-value obj 'dibujo (COMMON-GRAPHICS:make-box x y 
             (+ x (* *pixel-por-unidad* (first (get-value obj 'dimension))))
             (- y (* *pixel-por-unidad* (second (get-value obj 'dimension))))))
  (COMMON-GRAPHICS:draw-box mi-ventana (get-value obj 'dibujo))
  )

(defun pintar-circulo(obj)
  ;; obj es el nombre del bloque a pintar con propiedades
  ;; posicion, (posx posy)  y dimension, un entero

  (setf x (+ *inicio-ventana-horizontal* 
             (* *pixel-por-unidad* (first (get-value obj 'posicion)))))
  (setf y (- *inicio-ventana-vertical* 
             (* *pixel-por-unidad* (second (get-value obj 'posicion)))))
  (set-value obj 'dibujo (COMMON-GRAPHICS:draw-circle mi-ventana (COMMON-GRAPHICS:make-position 
             (+ x (/ (* *pixel-por-unidad* (first (get-value obj 'dimension))) 2))
             (- y (/ (* *pixel-por-unidad* (second (get-value obj 'dimension))) 2))) 
             (/ (* *pixel-por-unidad* (first (get-value obj 'dimension))) 2)))
  )

(defun pintar-triangulo(obj)
  ;; obj es el nombre del bloque a pintar con propiedades
  ;; posicion, (posx posy)  y dimension, un entero
  (setf x (+ *inicio-ventana-horizontal* 
             (* *pixel-por-unidad* (first (get-value obj 'posicion)))))
  (setf y (- *inicio-ventana-vertical* 
             (* *pixel-por-unidad* (second (get-value obj 'posicion)))))
  (setf base (* *pixel-por-unidad* (first (get-value obj 'dimension))))
  (COMMON-GRAPHICS:draw-line mi-ventana (COMMON-GRAPHICS:make-position x y) 
                             (COMMON-GRAPHICS:make-position (+ x base) y))
  (COMMON-GRAPHICS:draw-line mi-ventana (COMMON-GRAPHICS:make-position x y) 
                             (COMMON-GRAPHICS:make-position (+ x (/ base 2)) (- y base)))
  (COMMON-GRAPHICS:draw-line mi-ventana (COMMON-GRAPHICS:make-position (+ x (/ base 2)) (- y base)) 
                             (COMMON-GRAPHICS:make-position (+ x base) y)))


;;(draw-line mi-ventana (make-position 100 100) (make-position 200 200))


;;esconder la ventana:

(defun borrar-ventana()
  (COMMON-GRAPHICS:shrink-window mi-ventana t)
  )




